#include <bits/stdc++.h>

using namespace std;

int main()
{
    int t;
    cin>>t;
    int n[t], m[t], rezz[t];
    for(int i=0; i<t; i++)
    {
        cin>>n[i]>>m[i];
        rezz[i]=1;
        long long a[n[i]], b[m[i]], razlika=1e18;
        for(int l=0; l<n[i]; l++)cin>>a[l];
        for(int l=0; l<m[i]; l++)cin>>b[l];
        sort(a, a+n[i]);
        for(int j=n[i]-1; j>0; j--)
        {
            if(a[j]-a[j-1]<razlika)razlika=a[j]-a[j-1];
        }
        long long mod=a[0]%razlika;

        for(int j=0; j<n[i]; j++)
            {if(a[j]%razlika!=mod){rezz[i]=0; break;}}
        for(int j=0; j<m[i]; j++)
            {if(b[j]%razlika==mod){rezz[i]=0; break;}}
    }
    for(int i=0; i<t; i++)cout<<rezz[i]<<endl;
    return 0;
}